# Social Auth Steemconnect module

## Introduction

Social Auth Steemconnect Module is a Steemconnect Authentication integration for Drupal.

## Requirements

This module requires the following modules:

+ Social Auth (https://drupal.org/project/social_auth)
+ Social API (https://drupal.org/project/social_api)


## Recommended modules

+ Composer Manager (https://www.drupal.org/project/composer_manager): This module will help to install the League PHP library and Steemconnect base library for the league (guix77/oauth2-steemconnect), which are the libraries required to make user authentication. If you are already building your site with Composer (using https://github.com/drupal-composer/drupal-project for instance), there is no need for this module.

## Installation

+ Download Steemconnect Base Library for TheLeague OAuth2 PHP library (https://github.com/guix77/oauth2-steemconnect). We recommend to use Composer Manager module to install the library, or bulding your site with Composer (using https://github.com/drupal-composer/drupal-project for instance).
+ Install the dependencies: Social API and Social Auth. As of 2018-01-07, 2.x-dev versions and required for both.
+ Install as you would normally install a contributed Drupal module. See: https://drupal.org/documentation/install/modules-themes/modules-8 for further information.

## Configuration

+ Add your Steemconnect project OAuth information in Configuration » User Authentication » Steemconnect.
+ Place the Social Auth Login block in Structure » Block Layout.
+ If you already have a Social Auth Login block in the site, rebuild the cache.

## How it works

User can click on the Steemconnect logo on the Social Auth Login block. You can also add a button or link anywhere on the site that points to /user/login/steemconnect, so theming and customizing the button or link is very flexible.

When the user opens the /user/login/steemconnect link, it automatically takes user to Steemconnect for authentication. Steemconnect then returns the user to Drupal site.

One thing to note is that Steemconnect does NOT provide the user email. Since we need an email anyway, a fake email is generated by oauth2-steemconnect. The email will be the Steemconnect account ID followed by @fake-steemconnect-email.com. It's not ideal and it's a workaround for the moment. Your toughts (and PRs !!!) on this topic are welcome on https://github.com/guix77/oauth2-steemconnect/issues (this Drupal module developer also developped this Steemconnect Oauth2 League provider).

If we have an existing Drupal user with the same fake email address provided by oauth2-steemconnect with Steemconnect information, that user is logged in. Otherwise a new Drupal user is created.

## Support requests

Before posting a support request, carefully read the installation instructions provided in module documentation page.

Before posting a support request, check Composer Manager status report at admin/reports/composer-manager. This status page will show the Steemconnect The League OAuth2 Base PHP library version if Drupal can detect it.

Before posting a support request, check Recent log entries at admin/reports/dblog

Please also check the Steemconnect wiki first: https://github.com/steemit/steemconnect/wiki

Once you have done this, you can post a support request at module issue queue: https://www.drupal.org/project/issues/social_auth_steemconnect?categories=All

When posting a support request, please inform what does the status report say at admin/reports/composer-manager and if you were able to see any errors in Recent log entries.

## Credits

Current maintainer:
+ Guillaume Duveau (https://www.drupal.org/user/173213)

Original developer:
+ Guillaume Duveau (https://www.drupal.org/user/173213)

Original idea and proposal by:
+ Gokul NK (https://www.drupal.org/u/gokulnk)

Gokul NK posted a proposal of this module on https://steemit.com/utopian-io/@gokulnk/socialauth-steemconnect-module-for-drupal, registred the Drupal project on https://www.drupal.org/project/social_auth_steemconnect. Guillaume Duveau developed this Drupal module and the Steemconnect oAuth2 provider for the League oAuth2 client.

This module was created using https://www.drupal.org/project/social_auth_github as a template.

## Donations

If you want to support the original module developer and current maintainer, donations are welcome at:
+ Steemit: @guix77 / https://steemit.com/@guix77
+ Bitcoin: 12BkpRaeAPcUvxft5yWrSxtknVe7jNUNer
+ Ethereum and Ethereum-based (ERC-20) Tokens: 0xa32e0e0a0C8Aa10ac70a2827cB20641850824eEc
+ Cardano: DdzFFzCqrhsfUhaNNWuV1BSgjXC5ySNMhfPFRASXTkj26qCKoyYSbW3qWzQucuVLU2AE6AzuYiEfgHnc3DwhSyofeqZZxzANVMLBpDxp
+ Paypal : guillaume.duveau@gmail.com
